function [cImageApprox cCoefficients cIndex nCoefficients nZeroBlocks] = ...
    ApproxCellImageSCEIFS(cImage, tolerance, sDictionary, algorithm)

% Approximate a Blocked image using a seperable dictionary using a
% specified greedy algorithm.

if nargin < 3
    error('Not enough input arguments!');
elseif nargin < 4
    algorithm = 'OMP';
end

[blockHeight blockWidth nColours] = size(cImage{1});
[nRowBlocks, nColumnBlocks] = size(cImage);

% Only using one dictionary
if blockHeight ~= blockWidth
    
    error('%s: Only using one dictionary, blocks must be square!',mfilename);
    
end

fhandle = str2func(algorithm);
% Initialize return cells
% < < - - #
    cImageApprox = cell(nRowBlocks,nColumnBlocks);
    cIndex = cell(nRowBlocks,nColumnBlocks);
    cCoefficients = cell(nRowBlocks,nColumnBlocks);
% - - > > #

% Initialize counters
% < < - - #
    nCoefficients = 0;
    nZeroBlocks = 0;
% - - > > #

for i = 1:nRowBlocks
    
    for j = 1:nColumnBlocks
            
            % NEEDS REWRITING TO
            %{
            if strcmp(algorithm,'MP2D')
                [cImageApprox{i,j},iD1,iD2,cCoefficients{i,j},...
                    iDXY] = MP2D(cImage{i,j},...
                    sDictionary.mDictionary, sDictionary.mDictionary,tolerance);
            else
            %}                
            [cImageApprox{i,j},vID1,vID2,beta,cCoefficients{i,j},Q,vIDXY,...
                zeroBlock] = fhandle( cImage{i,j}, sDictionary.mDictionary, ...
                sDictionary.mDictionary, tolerance);
            
            nCoefficients = nCoefficients + numel(cCoefficients{i,j});
            % Keep track of the number of zero intensity blocks
            % < < - - #
                if zeroBlock
                    nZeroBlocks = nZeroBlocks + 1;
                end
            % - - > > #
            
            % Update the indexes
            % < < - -
                cIndex{i,j} = vIDXY;
                
                % Removed to decrease processing time
%                 cIndex{i,j}.vIMDictionary2D = vIDXY;
%                 [cIndex{i,j}.vID1, cIndex{i,j}.vIV1] = ...
%                     SubDictionaryIndex(vID1,sDictionary.vSize);
%                 [cIndex{i,j}.vID2, cIndex{i,j}.vIV2] = ...
%                     SubDictionaryIndex(vID2,sDictionary.vSize);
%                 cIndex{i,j}.vIRow = vID1;
%                 cIndex{i,j}.vIColumn = vID2;
            % - - > >
 
    end    
end