function mImage = CheckBlocking(mImage, blockHeight, blockWidth)

% Check RGB image
% <<--
% if ~strcmp(sImageRGB.colourType, 'truecolor')
% 
%     error('Supplied image should be RGB!');
%     
% end
% -->>

[y x z] = size(mImage);

if mod(y,blockHeight) || mod(x,blockWidth);
    
    fprintf('A %ix%i image cannot be split exactly into blocks of %i x %i,\nResizing.........\n',y,x,blockHeight,blockWidth);
    nYBlocks =floor(size(mImage,1)/blockHeight);
    nXBlocks =floor(size(mImage,2)/blockWidth);
    newY = nYBlocks*blockWidth;
    newX = nXBlocks*blockWidth;
    if newY == 0 || newX == 0
        error('Image is too small to be split into square blocks!!!!');
    end
    mImage=mImage(1:newY,1:newX,:);
    fprintf('New image is  %ix%i pixels.\n',newY,newX);
    
end