function [mImageRecon cImage cImageIndex] = Expand(mLoadedImage,...
    sApproxDetails,publicKey,privateKey,sBlockDims)

if nargin < 5
    % Default block processing dimentions
        sBlockDims.approxHeight = 8;
        sBlockDims.approxWidth = 8;
        sBlockDims.indexHeight = 8;
        sBlockDims.indexWidth = 8;
    % - - > > #
end


% Fixed parameters
    % Use rotation for the encryption operation
        rotate = 1;
    % - - > > 
% - - > > #
    
% Get the number of color channels
    nChannels = size(mLoadedImage,3);
% - - > > #

% Flatten the image and retrieve the plain text vector
    maxIntensitySave = 2^16-1;
    [vImage vPlainText vNCnPlain approxType meanAdj] = ReshapeE(nChannels,...
        mLoadedImage,maxIntensitySave);
% - - > > #

% Adjust vNCnPlain back
    vNCnPlain = vNCnPlain - meanAdj;
% - - > > #
       
% Populate sPlainText from vPlainText
    sPlainText = SPlainTextE(vPlainText,approxType,maxIntensitySave);
% - - > > #
    
% # of indexes and coefficients
%  # of indexes is determined by # of coefficients and approx method
% nIndexPlains and nImagePlains - this should be inside SPlainTextE ....
    if approxType == 1
        nIndexes = sPlainText.nCoefficients;
    elseif approxType == 2
        nIndexes = sPlainText.nCoefficients;
    elseif approxType == 3;
        nIndexes = sPlainText.nCoefficients/3;
        % # or rows per image is the same
            sPlainText.vNRowsImage = sPlainText.vNRowsImage*ones(1,3);
        % - - > > #
        % # of coefficients is also the same
            sPlainText.nCoefficients = (sPlainText.nCoefficients/3)*ones(1,3);
        % - - > > #
    end
% - - > > #    


% Calculate the number of pixels in vImage to get vNImagePixels and
% vNIndexPixels
vNImagePixels = CalcNPixles(sPlainText.nCoefficients,...
    sBlockDims.approxHeight,sBlockDims.approxWidth);

vNIndexPixels = CalcNPixles(nIndexes,...
    sBlockDims.indexHeight,sBlockDims.indexWidth,1);


% [vNImagePixels vNIndexPixels] = CalcNPixles(sPlainText.nCoefficients,...
%     sBlockDims.foldedHeight,sBlockDims.foldedHeight);

% Pass image pixels to RFlatten
nPixelsImage = sum(vNImagePixels);
cImage = FlattenR(vImage(1:nPixelsImage),sBlockDims.approxHeight,...
    vNImagePixels,sPlainText.nXBlocks*sBlockDims.approxWidth);
% cImage = FlattenR(vImage,blockHeight,vNPixels,nColumns)
% Pass the index pixles to RFlatten
cImageIndex = FlattenR(vImage(nPixelsImage+1:end),sBlockDims.approxHeight,...
    vNIndexPixels,sPlainText.nXBlocks*sBlockDims.approxWidth);

% Need to deal with the last row seperatly
% ceil(nCoefficients for each plain / blockWidth*blockeight)

% Loop though each plain first take whole rows and reverse the reshape
% operation, then take the last row.

% Split into vImage and vIndex - 

% Reshape to cells of images and indexes using nCoefficients per plain
% See JoinImageIndex
% Take all 

% Split the image
%     [mImageFolded mIndexFolded] = SplitImageIndex(mImageGrey,...
%         sPlainText.vNRowsImage);
% - - > > #

% Reform to folded image and index for each channel
%     [cImageIndex cIndexIm] = JoinImageIndex(mImageFolded,mIndexFolded,...
%         sPlainText.vNRowsImage,...
%         sPlainText.vNRowsIndex);
%     [cImage cImageIndex] = vImageToCell(vImage,sPlainText.nCoefficients,...
%         nIndexes,sBlockDims.approxWidth,sBlockWidth.approxHeight);    
% - - > > #

% Seperate the folded images into cells
%     cImage = CellImage(mImageFolded,sPlainText.vNRowsImage);
% - - > > #
        
% Rescale the image and index matrices - change to process cells
%     [mImageFolded, mIndexFolded] = RescaleFromSave(mImageFolded,mIndexFolded,...
%         sPlainText.sRescaleImage);
    [cImage cImageIndex] = RescaleFromSave(cImage,cImageIndex,...
        sPlainText.sRescaleImage,maxIntensitySave);
% - - > > #
   
% Set up the dictionary
    sDictionary = Dictionary(sApproxDetails.sDetails,sBlockDims.approxHeight,1);
% - - > > #


% for i = 1:10
%     startTime = clock;
% Expand the indexes
%   Assumes that nCoefficients is correctly returned by summing nCnPerBlock
%   - change to process cImageIndex
    cIndex = ExpandIndex(cImageIndex,...
        sPlainText.nXBlocks,sPlainText.nYBlocks,nIndexes,vNCnPlain,sBlockDims,...
        sPlainText.sRescaleIndex,sDictionary.vSize,publicKey, privateKey,rotate);
% - - > > #

% nCoefficients = sum(nCoefficients(:));
% Expand the image.
% Change to process cImage
    mImageRecon = ExpandImage(cImage,sPlainText.vNRowsImage,cIndex,...
        sPlainText.nCoefficients,sApproxDetails,sBlockDims,publicKey,privateKey,...
        rotate);
% - - > > #
%     vEndTime(i) = etime(clock,startTime);
% end
% avTime = mean(vEndTime)
        