function [cIndex cMNCnPerBlock] = ExpandIndexRGB(cIndexFolded,...
    nXBlocks,nYBlocks,vNIndexes,vNCnPlain,sBlockDims,sRescale,varargin)

% Wrapper to call ExpandIndexGrey for each colour plain


% Block dimensions
    nBlocks = nYBlocks*nXBlocks;
    nPixelsBlock = sBlockDims.indexWidth*sBlockDims.indexHeight;
% - - > >

% Initialize return values
    cIndex = cell(3,1);
    cMNCnPerBlock = cell(3,1);
% - - > > #

% Call ExpandIndexGrey for each colour plain
    iVNCnPlain = 1;
    for i = 1:3
        
        % Get # of atoms chosen per block, sent as plain text
            nIndexBlocks = ceil(vNIndexes(i)/(nPixelsBlock -1));
            nPlainText = nBlocks - nIndexBlocks;
            vTemp = vNCnPlain(iVNCnPlain:iVNCnPlain + nPlainText -1);
            iVNCnPlain = iVNCnPlain + nPlainText;
        % - - > >

        % Execute target function
            [cIndex{i} cMNCnPerBlock{i}] = ExpandIndexGrey(cIndexFolded{i},...
                nXBlocks,nYBlocks,vNIndexes(i),vTemp,sBlockDims,sRescale{i},...
                varargin{:});
        % - - > > 
        
        % Increment the public key
            varargin{2} = varargin{2} + 1;
        % - - > >
        
    end
% - - > > #
   