function [cFoldedImage cEmbeddedImage cImageHost vIXBlockEnd] = FoldApproxRGB...
    (sImageApprox,sDictionary,varargin)
%sBlockDims,publicKey,privateKey,rotate,sTuning)

% Process the three colour plains independantly calling FoldApproxGrey on
% each one.

% PrintWithStars([mfilename ,' Routine Called']);

% Initialze the return structures
%   Place images one on top of each other in cell, cell2mat will then give
% place them one on top of the other.
% < < - - #
    cFoldedImage = cell(sImageApprox.z,1);
    cEmbeddedImage = cell(sImageApprox.z,1);
% - - > > #

% Do not depend on the colour plain
    sImage.x = sImageApprox.x;
    sImage.y = sImageApprox.y;
    sImage.z = 1;
    sImage.blockWidth = sImageApprox.blockWidth;
    sImage.blockHeight = sImageApprox.blockHeight;
    sImage.nYBlocks = sImageApprox.nYBlocks;
    sImage.nXBlocks = sImageApprox.nXBlocks;
    sImage.maxIntensity = sImageApprox.maxIntensity;
% - - > > #

% For each colour plane call FoldApproxGrey and store the results
for iColour = 1:sImageApprox.z
    
    % Set up structure for one plane of the image
    % < < - - #
        sImage.cCoefficients = sImageApprox.cCoefficients{iColour};
        sImage.cIndex = sImageApprox.cIndex{iColour};
        sImage.nCoefficients = sImageApprox.nCoefficients(iColour);
        sImage.mImageApprox = sImageApprox.mImageApprox(:,:,iColour);
    % - - > > #
        
    % Execute target function
    % < < - - #
        [cFoldedImage{iColour} cEmbeddedImage{iColour} sImageHost iXBlockEnd]...
            = FoldApproxGrey(sImage,sDictionary,varargin{:});
    % - - > > #
    
    % Increment the public key
        varargin{2} = varargin{2} + 1;
    % - - > >
    
    vIXBlockEnd(iColour) = iXBlockEnd;
    cImageHost{iColour} = sImageHost.mImageHost;
    
end