function mImage = LoadImageRaw(imagePath,precision)

    % Loads an image from a raw file.  The last 3 elements of the file are
    % the original dimensions
    
    % Test extension is .raw
    % < < - - #
        [pathstr,name,ext] = fileparts(imagePath);
        if ~strcmp(ext,'.raw')
            error('File should be raw');
        end
    % - - > > #
    
    % Open a file for reading
    % <<--
        fid = fopen(imagePath,'r');
    % -->>
    
    % Read the whole file
    % <<--
        vFile = fread(fid,inf,precision);
    % -->>
    
    % Close the file
    % <<--
        fclose(fid);
    % -->>
    
    % Get the dimensions of the original image
    %   This is the last three elements of the file - x y z
    % <<--
        z = vFile(end); 
        y = vFile(end-1);
        x = vFile(end-2);
    % -->>
    
    % Reshape the vector back to a file of dimensions [x y z]
    % <<--
        mImage = feval(str2func(precision),reshape(vFile(1:end-3),x,y,z));
    % -->>
    
end
    


