function [c1,c2] = RescaleFromSave(c1,c2,sRescale,maxV)

% Rescales m1 and m2 back to their original ranges specified in sRescale.

% Rescale m1
%     m1 = RescaleInt(m1,sRescale.minM1,sRescale.maxM1);
%     c1 = cellfun(@(x,m,M) Rescale(x,m,M),c1,sRescale.minM1,sRescale.maxM1,...
%         'UniformOutput',0);
    c1 = cellfun(@(x,m,M) RescaleIntB(x,m,M,maxV),c1,sRescale.minM1,...
        sRescale.maxM1,'UniformOutput',0);    
    
% - - > > #

% Rescale m2
%     m2 =  RescaleInt(m2,sRescale.minM2,sRescale.maxM2);
    % Remove constant
%     if sRescale.minM2{1} == sRescale.maxM2{1}
%         c2 = cellfun(@(x,n) (x + n),c2,sRescale.minM2,'UniformOutput',0);
%     else
%         c2 = cellfun(@(x,m,M) Rescale(x,m,M),c2,sRescale.minM2,sRescale.maxM2,...
%             'UniformOutput',0);
%     end
    c2 = cellfun(@(x,m,M) RescaleIntB(x,m,M,maxV),c2,sRescale.minM2,...
        sRescale.maxM2,'UniformOutput',0);

% - - > > #